import 'package:build/build.dart';
import 'package:dev_compiler/src/compiler/command.dart';
import 'dart:async';
import 'package:dev_compiler/src/compiler/compiler.dart';
import 'package:analyzer/src/summary/package_bundle_reader.dart';
import 'package:path/path.dart' as path;
import 'package:dev_compiler/src/analyzer/context.dart';


class CollectPackageSources implements Builder {
  String mainPackage;
  String packageName;
  List<AssetId> packages=[];

  CollectPackageSources(this.mainPackage,this.packageName);

  @override
  Future build(BuildStep buildStep) async {
    // TODO: implement build
    print("Collectiong :${buildStep.input.id}");

    packages.add(buildStep.input.id);
  }

  @override
  List<AssetId> declareOutputs(AssetId inputId) {
    print("DEL ${inputId}");
    return [new AssetId(mainPackage,inputId.path).changeExtension(".collected")];
  }
}

/*
class DevCompilerBuilder implements Builder {

  @override
  Future build(BuildStep buildStep) {

    ModuleCompiler moduleCompiler =  new ModuleCompiler(new AnalyzerOptions());
    CompilerOptions compilerOptions = new CompilerOptions();
    buildStep.

    BuildUnit bu = new BuildUnit("module_name", "", sources, libraryToModule)

    new CompileCommand().run();
  }

  @override
  List<AssetId> declareOutputs(AssetId inputId) {
    return [inputId.changeExtension(".js"),inputId.changeExtension(".sum")];
  }

  String _moduleForLibrary(String moduleRoot, Source source) {
    if (source is InSummarySource) {
      var summaryPath = source.summaryPath;
      var ext = '.sum';
      if (path.isWithin(moduleRoot, summaryPath) && summaryPath.endsWith(ext)) {
        var buildUnitPath =
            summaryPath.substring(0, summaryPath.length - ext.length);
        return path.relative(buildUnitPath, from: moduleRoot);
      }

      throw
          'Imported file ${source.uri} is not within the module root '
          'directory $moduleRoot';
    }

    throw
        'Imported file "${source.uri}" was not found as a summary or source '
        'file. Please pass in either the summary or the source file '
        'for this import.';
  }
}
*/

main() async {
  var phases = new PhaseGroup();

  CollectPackageSources collector = new CollectPackageSources("b","a0");

  Phase collectPhase = phases.newPhase();
  collectPhase
      ..addAction(collector, new InputSet('a0', ['lib/*']))
      ..addAction(collector, new InputSet('a1', ['lib/*']))
      ..addAction(collector, new InputSet('b', ['*']));

//    ..newPhase()
//      ..addAction(
//        new DevCompilerBuilder(), new InputSet('a0', ['lib/*.dart']));

  await build(phases);
}
